Index: tmp/org.txm.setups/nsis/Examples/Plugin/nsis/pluginapi.h
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/nsis/pluginapi.h	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/nsis/pluginapi.h	(revision 2956)
@@ -6,9 +6,10 @@
 #endif
 
 #include "api.h"
+#include "nsis_tchar.h" // BUGBUG: Why cannot our plugins use the compilers tchar.h?
 
 #ifndef NSISCALL
-#  define NSISCALL __stdcall
+#  define NSISCALL WINAPI
 #endif
 
 #define EXDLL_INIT()           {  \
@@ -18,7 +19,11 @@
 
 typedef struct _stack_t {
   struct _stack_t *next;
-  char text[1]; // this should be the length of string_size
+#ifdef UNICODE
+  WCHAR text[1]; // this should be the length of g_stringsize when allocating
+#else
+  char text[1];
+#endif
 } stack_t;
 
 enum
@@ -53,20 +58,49 @@
 
 extern unsigned int g_stringsize;
 extern stack_t **g_stacktop;
-extern char *g_variables;
+extern LPTSTR g_variables;
 
-int NSISCALL popstring(char *str); // 0 on success, 1 on empty stack
-int NSISCALL popstringn(char *str, int maxlen); // with length limit, pass 0 for g_stringsize
-int NSISCALL popint(); // pops an integer
+void NSISCALL pushstring(LPCTSTR str);
+void NSISCALL pushintptr(INT_PTR value);
+#define pushint(v) pushintptr((INT_PTR)(v))
+int NSISCALL popstring(LPTSTR str); // 0 on success, 1 on empty stack
+int NSISCALL popstringn(LPTSTR str, int maxlen); // with length limit, pass 0 for g_stringsize
+INT_PTR NSISCALL popintptr();
+#define popint() ( (int) popintptr() )
 int NSISCALL popint_or(); // with support for or'ing (2|4|8)
-int NSISCALL myatoi(const char *s); // converts a string to an integer
-unsigned NSISCALL myatou(const char *s); // converts a string to an unsigned integer, decimal only
-int NSISCALL myatoi_or(const char *s); // with support for or'ing (2|4|8)
-void NSISCALL pushstring(const char *str);
-void NSISCALL pushint(int value);
-char * NSISCALL getuservariable(const int varnum);
-void NSISCALL setuservariable(const int varnum, const char *var);
+INT_PTR NSISCALL nsishelper_str_to_ptr(LPCTSTR s);
+#define myatoi(s) ( (int) nsishelper_str_to_ptr(s) ) // converts a string to an integer
+unsigned int NSISCALL myatou(LPCTSTR s); // converts a string to an unsigned integer, decimal only
+int NSISCALL myatoi_or(LPCTSTR s); // with support for or'ing (2|4|8)
+LPTSTR NSISCALL getuservariable(const int varnum);
+void NSISCALL setuservariable(const int varnum, LPCTSTR var);
 
+#ifdef UNICODE
+#define PopStringW(x) popstring(x)
+#define PushStringW(x) pushstring(x)
+#define SetUserVariableW(x,y) setuservariable(x,y)
+
+int  NSISCALL PopStringA(LPSTR ansiStr);
+void NSISCALL PushStringA(LPCSTR ansiStr);
+void NSISCALL GetUserVariableW(const int varnum, LPWSTR wideStr);
+void NSISCALL GetUserVariableA(const int varnum, LPSTR ansiStr);
+void NSISCALL SetUserVariableA(const int varnum, LPCSTR ansiStr);
+
+#else
+// ANSI defs
+
+#define PopStringA(x) popstring(x)
+#define PushStringA(x) pushstring(x)
+#define SetUserVariableA(x,y) setuservariable(x,y)
+
+int  NSISCALL PopStringW(LPWSTR wideStr);
+void NSISCALL PushStringW(LPWSTR wideStr);
+void NSISCALL GetUserVariableW(const int varnum, LPWSTR wideStr);
+void NSISCALL GetUserVariableA(const int varnum, LPSTR ansiStr);
+void NSISCALL SetUserVariableW(const int varnum, LPCWSTR wideStr);
+
+#endif
+
 #ifdef __cplusplus
 }
 #endif
Index: tmp/org.txm.setups/nsis/Examples/Plugin/exdll.dsp
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/exdll.dsp	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/exdll.dsp	(revision 2956)
@@ -52,8 +52,8 @@
 # ADD BASE BSC32 /nologo
 # ADD BSC32 /nologo
 LINK32=link.exe
-# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /machine:I386
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib nsis\pluginapi.lib /nologo /entry:"DllMain" /dll /machine:I386 /nodefaultlib /out:"../../Plugins/exdll.dll" /opt:nowin98
+# ADD BASE LINK32 user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib /nologo /dll /machine:I386
+# ADD LINK32 user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib nsis\pluginapi.lib /nologo /entry:"DllMain" /dll /machine:I386 /nodefaultlib /out:"../../Plugins/exdll.dll" /opt:nowin98
 # SUBTRACT LINK32 /pdb:none
 
 !ELSEIF  "$(CFG)" == "exdll - Win32 Debug"
@@ -79,8 +79,8 @@
 # ADD BASE BSC32 /nologo
 # ADD BSC32 /nologo
 LINK32=link.exe
-# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib nsis\pluginapi.lib /nologo /dll /debug /machine:I386 /pdbtype:sept
+# ADD BASE LINK32 user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib /nologo /dll /debug /machine:I386 /pdbtype:sept
+# ADD LINK32 user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib nsis\pluginapi.lib /nologo /dll /debug /machine:I386 /pdbtype:sept
 
 !ENDIF 
 
Index: tmp/org.txm.setups/nsis/Examples/Plugin/nsis.pas
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Plugin/nsis.pas	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Plugin/nsis.pas	(revision 2956)
@@ -50,9 +50,18 @@
     );
   TVariableList = INST_0..__INST_LAST;
 
+type
+  PluginCallbackMessages = (
+    NSPIM_UNLOAD,   // This is the last message a plugin gets, do final cleanup
+    NSPIM_GUIUNLOAD // Called after .onGUIEnd
+    );
+  TNSPIM = NSPIM_UNLOAD..NSPIM_GUIUNLOAD;
+
+  //TPluginCallback = function (const NSPIM: Integer): Pointer; cdecl;
+
   TExecuteCodeSegment = function (const funct_id: Integer; const parent: HWND): Integer;  stdcall;
-  Tvalidate_filename = procedure (const filename: PChar); cdecl;
-  TRegisterPluginCallback = function (const unknow: Integer; const uknown2: Integer): Integer; cdecl;
+  Tvalidate_filename = procedure (const filename: PChar); stdcall;
+  TRegisterPluginCallback = function (const DllInstance: HMODULE; const CallbackFunction: Pointer): Integer; stdcall;
 
   pexec_flags_t = ^exec_flags_t;
   exec_flags_t = record
@@ -75,7 +84,7 @@
   pextrap_t = ^extrap_t;
   extrap_t = record
     exec_flags: Pointer; // exec_flags_t;
-    exec_code_segment: Pointer; //  TFarProc;
+    exec_code_segment: TExecuteCodeSegment; //  TFarProc;
     validate_filename: Pointer; // Tvalidate_filename;
     RegisterPluginCallback: Pointer; //TRegisterPluginCallback;
   end;
@@ -93,10 +102,7 @@
   g_hwndParent: HWND;
   g_hwndList: HWND;
   g_hwndLogList: HWND;
-
   g_extraparameters: pextrap_t;
-  func : TExecuteCodeSegment;
-  extrap : extrap_t;
 
 procedure Init(const hwndParent: HWND; const string_size: integer; const variables: PChar; const stacktop: pointer; const extraparameters: pointer = nil);
 
@@ -116,23 +122,21 @@
   g_hwndParent := hwndParent;
   g_stacktop   := stacktop;
   g_variables  := variables;
-  g_hwndList := 0;
-  g_hwndList := FindWindowEx(FindWindowEx(g_hwndParent, 0, '#32770', nil), 0,'SysListView32', nil);
+  g_hwndList   := FindWindowEx(FindWindowEx(g_hwndParent, 0, '#32770', nil), 0,'SysListView32', nil);
   g_extraparameters := extraparameters;
-  extrap := g_extraparameters^;
 end;
 
+
 function Call(NSIS_func : String) : Integer;
 var
-  NSISFun: Integer; //The ID of nsis function
+  codeoffset: Integer; //The ID of nsis function
 begin
   Result := 0;
-  NSISFun := StrToIntDef(NSIS_func, 0);
-  if (NSISFun <> 0) and (g_extraparameters <> nil) then
+  codeoffset := StrToIntDef(NSIS_func, 0);
+  if (codeoffset <> 0) and (g_extraparameters <> nil) then
     begin
-    @func := extrap.exec_code_segment;
-    NSISFun := NSISFun - 1;
-    Result := func(NSISFun, g_hwndParent);
+    codeoffset := codeoffset - 1;
+    Result := g_extraparameters.exec_code_segment(codeoffset, g_hwndParent);
     end;
 end;
 
@@ -147,8 +151,8 @@
   ItemCount := SendMessage(g_hwndList, LVM_GETITEMCOUNT, 0, 0);
   item.iItem := ItemCount;
   item.mask := LVIF_TEXT;
-  item.pszText := PAnsiChar(Msg);
-  ListView_InsertItem(g_hwndList, item );
+  item.pszText := PChar(Msg);
+  ListView_InsertItem(g_hwndList, item);
   ListView_EnsureVisible(g_hwndList, ItemCount, TRUE);
 end;
 
@@ -191,8 +195,12 @@
 end;
 
 procedure NSISDialog(const text, caption: string; const buttons: integer);
+var
+  hwndOwner: HWND;
 begin
-  MessageBox(g_hwndParent, PChar(text), PChar(caption), buttons);
+  hwndOwner := g_hwndParent;
+  if not IsWindow(g_hwndParent) then hwndOwner := 0; // g_hwndParent is not valid in NSPIM_[GUI]UNLOAD
+  MessageBox(hwndOwner, PChar(text), PChar(caption), buttons);
 end;
 
 begin
Index: tmp/org.txm.setups/nsis/Examples/install-shared.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/install-shared.nsi	(revision 0)
+++ tmp/org.txm.setups/nsis/Examples/install-shared.nsi	(revision 2956)
@@ -0,0 +1,81 @@
+/*
+
+This example script installs a simple application for all users on a machine.
+
+All-users installers should only write to HKLM, $ProgramFiles, $CommonFiles and the 
+"All context" versions of $LocalAppData, $Templates, $SMPrograms etc.
+
+It should not write to HKCU nor any folders in the users profile!
+If the application requires writable template data in $AppData it 
+must copy the required files from a shared location the 
+first time a user launches the application.
+
+*/
+
+!define NAME "All-users example"
+!define REGPATH_UNINSTSUBKEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${NAME}"
+Name "${NAME}"
+OutFile "Install ${NAME}.exe"
+Unicode True
+RequestExecutionLevel Admin ; Request admin rights on WinVista+ (when UAC is turned on)
+InstallDir "$ProgramFiles\$(^Name)"
+InstallDirRegKey HKLM "${REGPATH_UNINSTSUBKEY}" "UninstallString"
+
+!include LogicLib.nsh
+!include Integration.nsh
+
+Page Directory
+Page InstFiles
+
+Uninstpage UninstConfirm
+Uninstpage InstFiles
+
+!macro EnsureAdminRights
+  UserInfo::GetAccountType
+  Pop $0
+  ${If} $0 != "admin" ; Require admin rights on WinNT4+
+    MessageBox MB_IconStop "Administrator rights required!"
+    SetErrorLevel 740 ; ERROR_ELEVATION_REQUIRED
+    Quit
+  ${EndIf}
+!macroend
+
+Function .onInit
+  SetShellVarContext All
+  !insertmacro EnsureAdminRights
+FunctionEnd
+
+Function un.onInit
+  SetShellVarContext All
+  !insertmacro EnsureAdminRights
+FunctionEnd
+
+
+Section "Program files (Required)"
+  SectionIn Ro
+
+  SetOutPath $InstDir
+  WriteUninstaller "$InstDir\Uninst.exe"
+  WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "DisplayName" "${NAME}"
+  WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "DisplayIcon" "$InstDir\MyApp.exe,0"
+  WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "UninstallString" '"$InstDir\Uninst.exe"'
+  WriteRegDWORD HKLM "${REGPATH_UNINSTSUBKEY}" "NoModify" 1
+  WriteRegDWORD HKLM "${REGPATH_UNINSTSUBKEY}" "NoRepair" 1
+
+  File "/oname=$InstDir\MyApp.exe" "${NSISDIR}\Bin\MakeLangId.exe" ; Pretend that we have a real application to install
+SectionEnd
+
+Section "Start Menu shortcut"
+  CreateShortcut /NoWorkingDir "$SMPrograms\${NAME}.lnk" "$InstDir\MyApp.exe"
+SectionEnd
+
+
+Section -Uninstall
+  ${UnpinShortcut} "$SMPrograms\${NAME}.lnk"
+  Delete "$SMPrograms\${NAME}.lnk"
+
+  Delete "$InstDir\MyApp.exe"
+  Delete "$InstDir\Uninst.exe"
+  RMDir "$InstDir"
+  DeleteRegKey HKLM "${REGPATH_UNINSTSUBKEY}"
+SectionEnd
Index: tmp/org.txm.setups/nsis/Examples/StartMenu/Example.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/StartMenu/Example.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/StartMenu/Example.nsi	(revision 2956)
@@ -40,11 +40,11 @@
 	StrCmp $R1 ">" skip
 
 		CreateDirectory $SMPROGRAMS\$R0
-		CreateShortCut $SMPROGRAMS\$R0\MakeNSISw.lnk $INSTDIR\makensisw.exe
+		CreateShortcut $SMPROGRAMS\$R0\MakeNSISw.lnk $INSTDIR\makensisw.exe
 
 		SetShellVarContext All
 		CreateDirectory $SMPROGRAMS\$R0
-		CreateShortCut "$SMPROGRAMS\$R0\All users MakeNSISw.lnk" $INSTDIR\makensisw.exe
+		CreateShortcut "$SMPROGRAMS\$R0\All users MakeNSISw.lnk" $INSTDIR\makensisw.exe
 
 	skip:
 SectionEnd
\ No newline at end of file
Index: tmp/org.txm.setups/nsis/Examples/Modern UI/WelcomeFinish.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Modern UI/WelcomeFinish.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Modern UI/WelcomeFinish.nsi	(revision 2956)
@@ -13,6 +13,7 @@
   ;Name and file
   Name "Modern UI Test"
   OutFile "WelcomeFinish.exe"
+  Unicode True
 
   ;Default installation folder
   InstallDir "$LOCALAPPDATA\Modern UI Test"
Index: tmp/org.txm.setups/nsis/Examples/Modern UI/MultiLanguage.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Modern UI/MultiLanguage.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Modern UI/MultiLanguage.nsi	(revision 2956)
@@ -2,6 +2,8 @@
 ;Multilingual Example Script
 ;Written by Joost Verburg
 
+!pragma warning error all
+
 ;--------------------------------
 ;Include Modern UI
 
@@ -10,6 +12,9 @@
 ;--------------------------------
 ;General
 
+  ;Properly display all languages (Installer will not work on Windows 95, 98 or ME!)
+  Unicode true
+
   ;Name and file
   Name "Modern UI Test"
   OutFile "MultiLanguage.exe"
@@ -28,6 +33,9 @@
 
   !define MUI_ABORTWARNING
 
+  ;Show all languages, despite user's codepage
+  !define MUI_LANGDLL_ALLLANGUAGES
+
 ;--------------------------------
 ;Language Selection Dialog Settings
 
@@ -39,18 +47,25 @@
 ;--------------------------------
 ;Pages
 
+  !insertmacro MUI_PAGE_WELCOME
   !insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Docs\Modern UI\License.txt"
   !insertmacro MUI_PAGE_COMPONENTS
   !insertmacro MUI_PAGE_DIRECTORY
   !insertmacro MUI_PAGE_INSTFILES
+  !insertmacro MUI_PAGE_FINISH
   
+  !insertmacro MUI_UNPAGE_WELCOME
   !insertmacro MUI_UNPAGE_CONFIRM
+  !insertmacro MUI_UNPAGE_LICENSE "${NSISDIR}\Docs\Modern UI\License.txt"
+  !insertmacro MUI_UNPAGE_COMPONENTS
+  !insertmacro MUI_UNPAGE_DIRECTORY
   !insertmacro MUI_UNPAGE_INSTFILES
+  !insertmacro MUI_UNPAGE_FINISH
 
 ;--------------------------------
 ;Languages
 
-  !insertmacro MUI_LANGUAGE "English" ;first language is the default language
+  !insertmacro MUI_LANGUAGE "English" ; The first language is the default language
   !insertmacro MUI_LANGUAGE "French"
   !insertmacro MUI_LANGUAGE "German"
   !insertmacro MUI_LANGUAGE "Spanish"
@@ -106,6 +121,17 @@
   !insertmacro MUI_LANGUAGE "Afrikaans"
   !insertmacro MUI_LANGUAGE "Catalan"
   !insertmacro MUI_LANGUAGE "Esperanto"
+  !insertmacro MUI_LANGUAGE "Asturian"
+  !insertmacro MUI_LANGUAGE "Basque"
+  !insertmacro MUI_LANGUAGE "Pashto"
+  !insertmacro MUI_LANGUAGE "ScotsGaelic"
+  !insertmacro MUI_LANGUAGE "Georgian"
+  !insertmacro MUI_LANGUAGE "Vietnamese"
+  !insertmacro MUI_LANGUAGE "Welsh"
+  !insertmacro MUI_LANGUAGE "Armenian"
+  !insertmacro MUI_LANGUAGE "Corsican"
+  !insertmacro MUI_LANGUAGE "Tatar"
+  !insertmacro MUI_LANGUAGE "Hindi"
 
 ;--------------------------------
 ;Reserve Files
Index: tmp/org.txm.setups/nsis/Examples/Modern UI/Basic.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Modern UI/Basic.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Modern UI/Basic.nsi	(revision 2956)
@@ -13,6 +13,7 @@
   ;Name and file
   Name "Modern UI Test"
   OutFile "Basic.exe"
+  Unicode True
 
   ;Default installation folder
   InstallDir "$LOCALAPPDATA\Modern UI Test"
Index: tmp/org.txm.setups/nsis/Examples/Modern UI/StartMenu.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Modern UI/StartMenu.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Modern UI/StartMenu.nsi	(revision 2956)
@@ -13,6 +13,7 @@
   ;Name and file
   Name "Modern UI Test"
   OutFile "StartMenu.exe"
+  Unicode True
 
   ;Default installation folder
   InstallDir "$LOCALAPPDATA\Modern UI Test"
@@ -76,7 +77,7 @@
     
     ;Create shortcuts
     CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
-    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
+    CreateShortcut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
   
   !insertmacro MUI_STARTMENU_WRITE_END
 
Index: tmp/org.txm.setups/nsis/Examples/Modern UI/HeaderBitmap.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/Modern UI/HeaderBitmap.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/Modern UI/HeaderBitmap.nsi	(revision 2956)
@@ -13,6 +13,7 @@
   ;Name and file
   Name "Modern UI Test"
   OutFile "HeaderBitmap.exe"
+  Unicode True
 
   ;Default installation folder
   InstallDir "$LOCALAPPDATA\Modern UI Test"
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/test.ini
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/test.ini	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/test.ini	(revision 2956)
@@ -41,12 +41,12 @@
 
 [Field 5]
 Type=FileRequest
-State=C:\poop.poop
+State=C:\dummy.xyz
 Left=10
 Right=-10
 Top=56
 Bottom=68
-Filter=Poop Files|*.poop|All files|*.*
+Filter=XYZ Files|*.xyz|All files|*.*
 Flags=GROUP|FILE_MUST_EXIST|FILE_EXPLORER|FILE_HIDEREADONLY
 
 [Field 6]
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.nsi	(revision 2956)
@@ -19,7 +19,7 @@
 ;Only useful for BZIP2 compression
 ;Use ReserveFile for your own InstallOptions INI files too!
 
-ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
+ReserveFile /plugin InstallOptions.dll
 ReserveFile "testlink.ini"
 
 ;Order of pages
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/testnotify.ini
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/testnotify.ini	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/testnotify.ini	(revision 2956)
@@ -41,8 +41,8 @@
 [Field 5]
 Type=FileRequest
 Flags=GROUP|FILE_MUST_EXIST|FILE_EXPLORER|FILE_HIDEREADONLY
-State=C:\poop.poop
-Filter=Poop Files|*.poop|All files|*.*
+State=C:\dummy.xyz
+Filter=XYZ Files|*.xyz|All files|*.*
 Left=10
 Right=-10
 Top=56
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/test.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/test.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/test.nsi	(revision 2956)
@@ -17,7 +17,7 @@
 ;Only useful for BZIP2 compression
 ;Use ReserveFile for your own InstallOptions INI files too!
 
-ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
+ReserveFile /plugin InstallOptions.dll
 ReserveFile "test.ini"
 
 ;Order of pages
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/testimgs.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/testimgs.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/testimgs.nsi	(revision 2956)
@@ -15,7 +15,7 @@
 ;Only useful for BZIP2 compression
 ;Use ReserveFile for your own InstallOptions INI files too!
 
-ReserveFile "${NSISDIR}\Plugins\InstallOptions.dll"
+ReserveFile /plugin InstallOptions.dll
 ReserveFile "testimgs.ini"
 ReserveFile "${NSISDIR}\Contrib\Graphics\Checks\colorful.bmp"
 ReserveFile "${NSISDIR}\Contrib\Graphics\Checks\modern.bmp"
Index: tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.ini
===================================================================
--- tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.ini	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/InstallOptions/testlink.ini	(revision 2956)
@@ -32,8 +32,8 @@
 Right=-40
 Top=70
 Bottom=80
-State=http://nsis.sourceforge.net/
-Text=* Homepage http://nsis.sourceforge.net/
+State=https://nsis.sourceforge.io/
+Text=* Homepage https://nsis.sourceforge.io/
 
 [Field 5]
 Type=Text
Index: tmp/org.txm.setups/nsis/Examples/nsDialogs/example.nsi
===================================================================
--- tmp/org.txm.setups/nsis/Examples/nsDialogs/example.nsi	(revision 2955)
+++ tmp/org.txm.setups/nsis/Examples/nsDialogs/example.nsi	(revision 2956)
@@ -1,20 +1,30 @@
-!include nsDialogs.nsh
-!include LogicLib.nsh
-
 Name "nsDialogs Example"
 OutFile "nsDialogs Example.exe"
+Caption "$(^Name)"
 
+Unicode True
 XPStyle on
+RequestExecutionLevel user
 
+!include nsDialogs.nsh
+!include LogicLib.nsh
+!include WinCore.nsh ; MAKELONG
+
+LicenseText "All the action takes place on the next page..." "Start"
+SubCaption 0 ": Ready?"
+
 Page license
 Page custom nsDialogsPage
+Page custom LBPage
+Page custom RangesPage
+Page custom NotifyPage
+!pragma warning disable 8000 ; "Page instfiles not used, no sections will be executed!"
 
 Var BUTTON
 Var EDIT
 Var CHECKBOX
 
 Function nsDialogsPage
-
 	nsDialogs::Create 1018
 	Pop $0
 
@@ -30,6 +40,7 @@
 	Pop $EDIT
 	GetFunctionAddress $0 OnChange
 	nsDialogs::OnChange $EDIT $0
+	${NSD_Edit_SetCueBannerText} $EDIT 0 "Type 'hello there' and get a free surprise"
 
 	${NSD_CreateCheckbox} 0 -50 100% 8u Test
 	Pop $CHECKBOX
@@ -40,43 +51,205 @@
 	Pop $0
 
 	nsDialogs::Show
-
 FunctionEnd
 
 Function OnClick
-
 	Pop $0 # HWND
-
 	MessageBox MB_OK clicky
-
 FunctionEnd
 
 Function OnChange
-
 	Pop $0 # HWND
 
-	System::Call user32::GetWindowText(i$EDIT,t.r0,i${NSIS_MAX_STRLEN})
-
+	System::Call user32::GetWindowText(p$EDIT,t.r0,i${NSIS_MAX_STRLEN})
 	${If} $0 == "hello there"
 		MessageBox MB_OK "right back at ya"
 	${EndIf}
-
 FunctionEnd
 
 Function OnBack
-
 	MessageBox MB_YESNO "are you sure?" IDYES +2
 	Abort
-
 FunctionEnd
 
 Function OnCheckbox
-
 	Pop $0 # HWND
-
 	MessageBox MB_OK "checkbox clicked"
+FunctionEnd
 
+!macro BeginControlsTestPage title
+	nsDialogs::Create 1018
+	Pop $0
+	${NSD_SetText} $hWndParent "$(^Name): ${title}"
+!macroend
+
+!macro CreateButton x y w h txt var handler data
+	${NSD_CreateButton} ${x} ${y} ${w} ${h} "${txt}"
+	Pop ${var}
+	nsDialogs::SetUserData ${var} ${data}
+	${NSD_OnClick} ${var} ${handler}
+!macroend
+
+
+Function LBPage
+	!insertmacro BeginControlsTestPage "ListBox"
+
+	${NSD_CreateSortedListBox} 1u 0 -2u 70u ""
+	Pop $1
+	${NSD_LB_AddString} $1 "Foo"
+	${NSD_LB_AddString} $1 "Bar"
+
+	StrCpy $9 1
+	${NSD_CreateText} 1u 75u -2u 12u "New item #$9"
+	Pop $EDIT
+	!insertmacro CreateButton 1u 90u 50u 12u "Add (&Sorted)" $0 LBAction Add
+	!insertmacro CreateButton 53u 90u 50u 12u "&Prepend" $0 LBAction Prepend
+	!insertmacro CreateButton 105u 90u 50u 12u "&Append" $0 LBAction Append
+	!insertmacro CreateButton 160u 90u 50u 12u "&Delete Last" $0 LBAction DL
+	!insertmacro CreateButton 215u 90u 50u 12u "&Clear" $0 LBAction Clear
+
+	nsDialogs::Show
 FunctionEnd
 
+Function LBAction
+	Pop $0
+	nsDialogs::GetUserData $0
+	Pop $0
+	${NSD_GetText} $EDIT $8
+
+	${Select} $0
+	${Case} "Add"
+		${NSD_LB_AddString} $1 $8
+	${Case} "Prepend"
+		${NSD_LB_PrependString} $1 $8
+	${Case} "Append"
+		${NSD_LB_AppendString} $1 $8
+	${Case} "DL"
+		${NSD_LB_GetCount} $1 $8
+		${If} $8 U> 0
+			IntOp $8 $8 - 1
+			${NSD_LB_DelItem} $1 $8
+		${EndIf}
+		Return
+	${Case} "Clear"
+		${NSD_LB_Clear} $1
+        Return
+	${EndSelect}
+
+	IntOp $9 $9 + 1
+	${NSD_SetText} $EDIT "New item #$9"
+FunctionEnd
+
+
+Function RangesPage
+	!insertmacro BeginControlsTestPage "Ranges"
+
+	${NSD_CreateHTrackBar} 1 0 -2 20u ""
+	Pop $1
+	${NSD_TrackBar_SetRangeMax} $1 10
+	${NSD_TrackBar_SetTicFreq} $1 1
+	${NSD_TrackBar_SetPos} $1 3
+
+	StrCpy $9 20 ; Progress pos
+	${NSD_CreateProgressBar} 1 25u -2 8u ""
+	Pop $2
+	${NSD_CreateTimer} RangesTimer 1000
+
+	${NSD_CreateNumber} 1 40u 50u 12u "42"
+	Pop $3
+	${NSD_CreateUpDown} 0 0 0 0 ""
+	Pop $4
+	${NSD_UD_SetBuddy} $4 $3
+	${MAKELONG} $5 $0 50 0 ; 0..50
+	${NSD_UD_SetPackedRange} $4 $5
+
+	nsDialogs::Show
+FunctionEnd
+
+Function RangesTimer
+	IntOp $9 $9 + 5
+	${IfThen} $9 > 100 ${|} StrCpy $9 0 ${|}
+	${NSD_ProgressBar_SetPos} $2 $9
+FunctionEnd
+
+
+Function NotifyPage
+	!insertmacro BeginControlsTestPage "WM_NOTIFY"
+
+	nsDialogs::CreateControl "${__NSD_RichEdit_CLASS_20A}" "${__NSD_RichEdit_STYLE}" "${__NSD_RichEdit_EXSTYLE}" 1 1 -2 50u "" ; Forcing ANSI control, see forums.winamp.com/showthread.php?p=3169999
+	Pop $9
+	${NSD_OnNotify} $9 OnNotify
+	IntOp $8 ${ENM_LINK} | ${ENM_KEYEVENTS}
+	${NSD_RichEd_SetEventMask} $9 $8
+	SendMessage $9 ${EM_AUTOURLDETECT} 1 0
+	${NSD_SetText} $9 "{\rtf1\ansi{\fonttbl\f0\fswiss Helvetica;}\f0\pard http://nsis.sf.net\par {\b Click the link!}\par\par Type something and I will block every other character...}"
+
+	${NSD_InitCommonControlsEx} ${ICC_DATE_CLASSES}
+	${NSD_CreateDatePicker} 1% 55u 48% 12u ""
+	Pop $1
+	${NSD_OnNotify} $1 onDateTimeNotify
+	${NSD_CreateLabel} 51% 56u 48% 12u "Change the date..."
+	Pop $9
+
+	/*
+	${NSD_CreateCalendar} 1% 23% 150u 90u ""
+	Pop $1
+	${NSD_AddStyle} $1 ${MCS_NOTODAY}
+	System::Call 'USER32::SendMessage(p$1, i${MCM_GETMINREQRECT}, p0, @r2)'
+	System::Call '*$2(i,i,i.r2,i.r3)'
+	#System::Call 'USER32::SendMessage(p$1, i${MCM_GETMAXTODAYWIDTH}, p0, *i0r4)'
+	#${IfThen} $4 > $2 ${|} StrCpy $2 $4 ${|}
+	System::Call 'USER32::SetWindowPos(p$1,p0,i,i,ir2,ir3,i0x16)'
+	*/
+
+	nsDialogs::Show
+FunctionEnd
+
+Function OnNotify
+	Pop $1 ; HWND
+	Pop $2 ; Code
+	Pop $3 ; NMHDR*
+	${If} $2 = ${EN_LINK}
+		System::Call '*$3(p,p,p,p.r2,p,p,i.r4,i.r5)' ; Extract from ENLINK*
+		${IfThen} $2 <> ${WM_LBUTTONDOWN} ${|} Return ${|}
+		IntOp $2 $5 - $4
+		System::Call '*(ir4,ir5,l,&t$2,i)p.r2' ; Create TEXTRANGE and a text buffer
+		${If} $2 P<> 0
+			IntPtrOp $3 $2 + 16 ; Find buffer
+			System::Call '*$2(i,i,p$3)' ; Set buffer in TEXTRANGE
+			SendMessage $1 ${EM_GETTEXTRANGE} "" $2 $4
+			${If} $4 <> 0
+				System::Call 'SHELL32::ShellExecute(p$hWndParent, p0, pr3, p0, p0, i 1)'
+			${EndIf}
+			System::Free $2
+		${EndIf}
+	${ElseIf} $2 = ${EN_MSGFILTER}
+		Var /Global Toggle
+		System::Call '*$3(p,i,i,i.r4)' ; MSGFILTER->msg
+		${If} $4 = ${WM_CHAR}
+			IntOp $Toggle $Toggle ^ 1
+			${If} $Toggle & 1
+				${NSD_Return} 1
+			${EndIf}
+		${EndIf}
+	${EndIf}
+FunctionEnd
+
+Function onDateTimeNotify
+Pop $1 ; HWND
+Pop $2 ; Code
+Pop $3 ; NMHDR*
+${If} $2 = ${DTN_DATETIMECHANGE}
+	System::Call 'USER32::SendMessage(p$1, i${DTM_GETSYSTEMTIME}, p0, @r3)i.r0'
+	${If} $0 = ${GDT_VALID}
+		System::Call '*$3(&i2.R1, &i2.R2, &i2, &i2.R3, &i2, &i2, &i2, &i2)' ; SYSTEMTIME
+		StrCpy $0 "$R1/$R2/$R3"
+	${Else}
+		StrCpy $0 "N/A"
+	${EndIf}
+	${NSD_SetText} $9 $0
+${EndIf}
+FunctionEnd
+
 Section
 SectionEnd
